﻿package fr.prechargement
{
	//import package display
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Loader;
	
	//import package events
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	
	//import autres
	import flash.text.TextField;
	import flash.filters.GlowFilter;
	import flash.net.URLRequest;
	
	//gestion des paramètres de la scène, vous devez les mofier en fonction de votre projet
	[SWF( width='600', height='400', frameRate='30', backgroundColor='#333333' )]
	
	//la classe Principale
	public class Precharg extends MovieClip
	{
		//variable permettant de modifier l'ensemble des couleur du projet (barre, filtre, texte)
		private const _couleur                               :uint = 0xff0000;
		//chemin du ficher à télécharger
		private const _addresse                               :String ="src/interface.swf";
		private var   _filtre                                :GlowFilter;
		private var   _barreCharge                           :MovieClip;
		private var   _infos                                 :TextField;
		private var   _barre                                 :Shape;
		private var   _loader                                :Loader;
		private var   _req                                   :URLRequest;
		private var   _centreY                               :int;
		
		public function Precharg ():void
		{
			//initialisation
			_barreCharge                                  = new MovieClip();
			_infos                                        = new TextField();
			_barre                                        = new Shape ();
			_loader                                       = new Loader ();
			_filtre                                       = new GlowFilter( _couleur, 1, 10, 10, 1, 3, false, false);
			_req                                          = new URLRequest( _addresse );
			
			_infos.textColor = _couleur;
			_infos.width = 28;
			_centreY = stage.stageHeight/2;
			
			_barre.graphics.beginFill ( _couleur );
			_barre.graphics.drawRect( 0, stage.stageHeight/2, 1, 4);
			_barreCharge.filters = [ _filtre ];
			
			this.addChild( _barreCharge );
			this.addChild( _infos );
			this._barreCharge.addChild( _barre );
			
			//chargement et ecoute de l'objet loader
			_loader.load( _req );
			_loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, $progression);
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, $chargeComplete);
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, $erreur);
		}
		//fonction gérant la progression (largeur de la barre et texte contenant le pourcentage).
		private function $progression ( e:ProgressEvent ):void
		{
			var _pct:int = Math.round( e.bytesLoaded / e.bytesTotal * 100 );
			_infos.text = _pct + "%";
			_infos.y = _centreY + 5;
			_infos.x = _barreCharge.x + _barreCharge.width + 5;
			_barreCharge.width = stage.stageWidth /100 * _pct;
		}
		//fonction joué une fois le chargement complété
		private function $chargeComplete ( e:Event ):void
		{
			//supression des écouteurs
			_loader.contentLoaderInfo.removeEventListener(ProgressEvent.PROGRESS, $progression);
			_loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, $chargeComplete);
			_loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, $erreur);
			
			//suppresssion des éléments graphiqueqs
			this.removeChild( _infos );
			this.removeChild( _barreCharge );
			_infos = null;
			_barreCharge = null;
			//affichage du loader
			this.addChild( _loader );
		}
		//fonction gérant les erreurs de chargement  liés au fichier chargé
		private function $erreur ( e:Event ):void
		{
			//suppression des écouteurs du loader
			_loader.contentLoaderInfo.removeEventListener(ProgressEvent.PROGRESS, $progression);
			_loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, $chargeComplete);
			_loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, $erreur);

			this.removeChild( _barreCharge );
			_barreCharge = null;
			
			//paramètrage du texte et mise en place du message d'erreur
			_ingos.selectable = false;
			_infos.text = "Erreur de chargement ...";
			_infos.width = 150;
			_infos.y = _centreY;
			_infos.x = stage.stageWidth - _infos.width /2;
		}
	}//fin classe
}//fin package